﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace LabelSystemVideo
{
    using System.IO;
    using System.Net;
    using System.Windows;
    using System.Windows.Media.Imaging;
    using System.Xml.Linq;
    using AForge.Video.DirectShow;
    using AForge.Video.FFMPEG;

    public partial class VideoForm : Form
    {
        // win 10开机启动 目录：C:\ProgramData\Microsoft\Windows\Start Menu\Programs\StartUp

        VideoCaptureDevice videoSource;
        DateTime dt = DateTime.Now;//开始录像时间
        Graphics g;
        private bool createNewFile = true;
        VideoFileWriter videoWriter = null;
        private bool stopREC = true;
        string path = string.Empty;
        string zPath = string.Empty;
        string MacAddressPath = string.Empty;
        private string videoFileFullPath = string.Empty;


        //设置摄像头旋转角度
        int dAngle = 0;

        //const string netWorkPath = @"\\192.168.1.212\Monitor";
        //const string netWorkUser = "admin";
        //const string netWorkPwd = "TAYG2403b";
        const string netWorkPath = @"\\172.16.4.160\Monitor";
        const string netWorkUser = "monitor";
        const string netWorkPwd = "spread";


        #region 窗口句柄重写，禁用窗体的关闭按钮      
        private const int CP_NOCLOSE_BUTTON = 0x200;
        //protected override CreateParams CreateParams
        //{
        //    get
        //    {
        //        CreateParams myCp = base.CreateParams;
        //        myCp.ClassStyle = myCp.ClassStyle | CP_NOCLOSE_BUTTON;
        //        return myCp;
        //    }
        //}
        #endregion

        public VideoForm()
        {
            InitializeComponent();
            MacAddressPath = GetMacAddress();
            var floderDate = string.Format(@"{0}\{1}\", DateTime.Now.ToString("yyyyMMdd"), MacAddressPath);
            path = $@"{Environment.GetFolderPath(Environment.SpecialFolder.MyVideos)}\KangHong\" + floderDate;
            path = Application.StartupPath + @"\VideoTmp\" + floderDate;
            zPath = @"Z:\KangHong\" + floderDate;
            dAngle = GetXMLAngleValue();

        }



        private void VideoForm_Load(object sender, EventArgs e)
        {
            bind();
        }

        #region 通过共享网络磁盘映射的方式，讲文件copy到指定网盘

        /// <summary>
        /// 通过共享网络磁盘映射的方式，讲文件copy到指定网盘
        /// </summary>
        /// <param name="strFromPath"></param>
        /// <param name="strToPath"></param>
        public static void CopyFolder(string strFromPath, string strToPath)
        {
            //如果源文件夹不存在，则创建
            if (!Directory.Exists(strFromPath))
            {
                Directory.CreateDirectory(strFromPath);
            }
            ////取得要拷贝的文件夹名
            //string strFolderName = strFromPath.Split(new string[] { "\\" }, StringSplitOptions.RemoveEmptyEntries).LastOrDefault();//strFromPath.Substring(strFromPath.LastIndexOf("\\") + 1, strFromPath.Length - strFromPath.LastIndexOf("\\") - 1);
            //如果目标文件夹中没有源文件夹则在目标文件夹中创建源文件夹
            //if (!Directory.Exists(strToPath + "\\" + strFolderName))
            //{
            //    Directory.CreateDirectory(strToPath + "\\" + strFolderName);
            //}
            if (!Directory.Exists(strToPath))
            {
                Directory.CreateDirectory(strToPath);
            }

            //直接剪切moveto，本地不留副本
            string[] strFiles = Directory.GetFiles(strFromPath);
            //循环剪切文件,此处循环是考虑每日工作站最后一个文件无法存储到根目录，导致出现两个视频文件的问题
            for (int i = 0; i < strFiles.Length; i++)
            {
                //取得文件名，只取文件名，地址截掉。
                string strFileName = strFiles[i].Substring(strFiles[i].LastIndexOf("\\") + 1, strFiles[i].Length - strFiles[i].LastIndexOf("\\") - 1);
                File.Move(strFiles[i], strToPath + "DT-" + strFileName);
            }


            #region V1.0: 全部存储到本地后，开机全部copy到网络目录后删除本地文件（批量）
            ////创建数组保存源文件夹下的文件名
            //string[] strFiles = Directory.GetFiles(strFromPath);
            ////循环拷贝文件
            //for (int i = 0; i < strFiles.Length; i++)
            //{
            //    //取得拷贝的文件名，只取文件名，地址截掉。
            //    string strFileName = strFiles[i].Substring(strFiles[i].LastIndexOf("\\") + 1, strFiles[i].Length - strFiles[i].LastIndexOf("\\") - 1);
            //    //开始拷贝文件,true表示覆盖同名文件
            //    File.Copy(strFiles[i], strToPath + "\\" + strFolderName + "\\" + strFileName, true);
            //}




            ////创建DirectoryInfo实例
            //DirectoryInfo dirInfo = new DirectoryInfo(strFromPath);
            ////取得源文件夹下的所有子文件夹名称
            //DirectoryInfo[] ZiPath = dirInfo.GetDirectories();
            //for (int j = 0; j < ZiPath.Length; j++)
            //{
            //    //获取所有子文件夹名
            //    string strZiPath = strFromPath + "\\" + ZiPath[j].ToString();
            //    //把得到的子文件夹当成新的源文件夹，从头开始新一轮的拷贝
            //    CopyFolder(strZiPath, strToPath + "\\" + strFolderName);
            //}

            ////递归copy后，删除原目录文件
            //for (int i = 0; i < strFiles.Length; i++)
            //{
            //    File.Delete(strFiles[i]);
            //} 
            #endregion

        }
        #endregion

        private void BtnRound_Click(object sender, EventArgs e)
        {
            dAngle = dAngle > 270 ? 90 : dAngle + 90;
            //将配置更新到XML
            UpdateXMLAngleValue(dAngle);
        }

        /// <summary>
        /// 获取配置文件中的视频角度配置信息
        /// </summary>
        /// <returns></returns>
        private int GetXMLAngleValue()
        {
            try
            {
                XDocument xdoc = XDocument.Load("videoSetting.xml");
                return int.Parse(xdoc.Element("dAngle").Value);
            }
            catch (Exception ex)
            {
                return 0;
            }
        }

        private void UpdateXMLAngleValue(int AngleValue)
        {
            XDocument xdoc = XDocument.Load("videoSetting.xml");
            xdoc.Element("dAngle").SetValue(AngleValue);
            xdoc.Save("videoSetting.xml");
        }


        //重截窗体的OnClosing方法
        protected override void OnClosing(CancelEventArgs e)
        {

            CloseCaptureDevice();
            //e.Cancel = true; //取消关闭操作

        }

        #region 监控bind
        /// <summary>
        /// 监控bind
        /// </summary>
        private void bind()
        {
            try
            {

                FilterInfoCollection videoDevices = new FilterInfoCollection(FilterCategory.VideoInputDevice);
                if (videoDevices.Count <= 0)
                {
                    MessageBox.Show("请连接摄像头");
                    return;
                }
                else
                {
                    CloseCaptureDevice();
                    if (!Directory.Exists(path)) Directory.CreateDirectory(path);

                    videoSource = new VideoCaptureDevice(videoDevices[0].MonikerString);
                    videoSource.VideoResolution = videoSource.VideoCapabilities[0];
                    sourcePlayer.VideoSource = videoSource;
                    sourcePlayer.Start();

                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }
        #endregion

        #region CloseCaptureDevice
        /// <summary>
        /// 关闭摄像头驱动
        /// </summary>
        private void CloseCaptureDevice()
        {
            if (videoSource != null)
            {
                if (videoSource.IsRunning)
                {
                    videoSource.SignalToStop();
                    videoSource.WaitForStop();
                    videoSource.Stop();
                }
                videoSource = null;
            }
        }
        #endregion

        #region 获取本机MAC地址和IP地址的方法
        /// <summary>
        /// 获取本机MAC地址方法
        /// </summary>
        /// <returns></returns>
        private string GetMacAddress()
        {
            try
            {
                //获取网卡硬件地址，需要添加引用：System.Management.dll
                string mac = "";
                System.Management.ManagementClass mc = new System.Management.ManagementClass("Win32_NetworkAdapterConfiguration");
                System.Management.ManagementObjectCollection moc = mc.GetInstances();
                foreach (System.Management.ManagementObject mo in moc)
                {
                    if ((bool)mo["IPEnabled"] == true)
                    {
                        mac = mo["MacAddress"].ToString();
                        var ipAddress = mo["IPAddress"];//包括IPv4和IPv6地址
                        break;
                    }
                }
                moc = null;
                mc = null;
                return mac.Replace(":", "-");
            }
            catch
            {
                return "unknow";
            }
        }
        #endregion

        private void btnVideoJT_Click(object sender, EventArgs e)
        {
            try
            {

                string pathp = $@"{Environment.GetFolderPath(Environment.SpecialFolder.MyPictures)}\";
                if (!Directory.Exists(pathp)) Directory.CreateDirectory(pathp);
                if (sourcePlayer.IsRunning)
                {
                    BitmapSource bitmapSource = System.Windows.Interop.Imaging.CreateBitmapSourceFromHBitmap(
                        sourcePlayer.GetCurrentVideoFrame().GetHbitmap(),
                        IntPtr.Zero,
                        Int32Rect.Empty,
                        BitmapSizeOptions.FromEmptyOptions());

                    PngBitmapEncoder pE = new PngBitmapEncoder();
                    pE.Frames.Add(BitmapFrame.Create(bitmapSource));
                    string picName = $"{pathp}{DateTime.Now.ToString("yyyyMMdd_HHmmssff")}.jpg";
                    if (File.Exists(picName))
                    {
                        File.Delete(picName);
                    }
                    using (Stream stream = File.Create(picName))
                    {
                        pE.Save(stream);
                    }
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }

        }

        #region 获取保存视频的磁盘信息
        /// <summary>
        /// 获取保存视频的磁盘信息
        /// </summary>
        bool TestDriveInfo(string n)
        {
            try
            {
                DriveInfo D = DriveInfo.GetDrives().Where(a => a.Name == path.Substring(0, 3).ToUpper()).FirstOrDefault();
                Int64 i = D.TotalFreeSpace, ti = 1;
                ti <<= 35;

                if (i < ti)
                {
                    DirectoryInfo folder = new DirectoryInfo(path + MacAddressPath + @"-Video\");
                    //modify by stephen，验证当前指定文件夹是否存在元素
                    if (folder.Exists)
                    {
                        // folder.GetFiles("*.wmv").OrderBy(a => a.CreationTime).ToList(); 
                        var fisList = folder.GetFiles("*.wmv").OrderBy(a => a.CreationTime);
                        //modify by stephen, 应该先验证集合是否存在子元素，然后才能tolist
                        if (fisList.Any())
                        {
                            List<FileInfo> fis = fisList.ToList();
                            if (fis.Count > 0 && fis[0].Name != n)
                            {
                                File.Delete(fis[0].FullName);
                            }
                        }
                    }


                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "处理硬盘信息出错");
                return false;
            }
            return true;
        }
        #endregion

        /// <summary>
        /// videosouceplayer 录像
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="image"></param>
        private void sourcePlayer_NewFrame(object sender, ref Bitmap image)
        {
            try
            {

                #region  设置摄像头旋转调整
                if (image != null)
                {
                    RotateFlipType pType = RotateFlipType.RotateNoneFlipNone;
                    if (dAngle == 0)
                    {
                        pType = RotateFlipType.RotateNoneFlipNone;
                    }
                    else if (dAngle == 90)
                    {
                        pType = RotateFlipType.Rotate90FlipNone;
                    }
                    else if (dAngle == 180)
                    {
                        pType = RotateFlipType.Rotate180FlipNone;
                    }
                    else if (dAngle == 270)
                    {
                        pType = RotateFlipType.Rotate270FlipNone;
                    }


                    // 实时按角度绘制
                    image.RotateFlip(pType);
                }
                #endregion

                //写到屏幕上的时间
                g = Graphics.FromImage(image);
                SolidBrush drawBrush = new SolidBrush(Color.Yellow);

                Font drawFont = new Font("Arial", 18, System.Drawing.FontStyle.Bold, GraphicsUnit.Pixel);
                int xPos = 10;
                int yPos = 10;

                string drawDate = DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss");
                g.DrawString(drawDate, drawFont, drawBrush, xPos, yPos);

                //save content
                string videoFileName = dt.ToString("yyyyMMdd_HHmmss") + ".wmv";




                if (TestDriveInfo(videoFileName)) //检测硬盘空间足够
                {
                    if (!stopREC)
                    {
                        stopREC = true;
                        createNewFile = true; //这里要设置为true表示要创建新文件
                        if (videoWriter != null) videoWriter.Close();
                    }
                    else
                    {
                        //开始录像
                        if (createNewFile)
                        {
                            //第二次录像不一定是第二次开启软件时间(比如：连续多小时录制)，所以应该重新给新录制视频文件重新赋值命名
                            dt = DateTime.Now;
                            videoFileFullPath = path + dt.ToString("yyyy-MM-dd HHmm") + ".wmv";//videoFileName;

                            createNewFile = false;
                            if (videoWriter != null)
                            {
                                videoWriter.Close();
                                videoWriter.Dispose();
                            }

                            videoWriter = new VideoFileWriter();
                            //这里必须是全路径，否则会默认保存到程序运行根据录下了
                            videoWriter.Open(videoFileFullPath, image.Width, image.Height, 30, VideoCodec.WMV1);
                            videoWriter.WriteVideoFrame(image);
                        }
                        else
                        {
                            if (videoWriter.IsOpen)
                            {
                                videoWriter.WriteVideoFrame(image);
                            }
                            if (dt.AddMinutes(1) <= DateTime.Now)
                            {

                                createNewFile = true;
                                //modify by stephen,每次写入视频文件后，即刻更新结束时间戳，并存入指定文件夹(目的：如果只有关闭的时候处理此操作，就会出现大于1小时的视频文件无法更新结束时间戳，且无法转入指定文件夹)
                                if (videoWriter != null)
                                {
                                    videoWriter.Close();
                                    videoWriter.Dispose();
                                }
                                string newPath = path + MacAddressPath + @"-Video\";
                                if (!Directory.Exists(newPath)) Directory.CreateDirectory(newPath);
                                string newStr = newPath + dt.ToString("yyyyMMddHHmm") + "-" + DateTime.Now.ToString("yyyyMMddHHmm") + ".wmv";
                                FileInfo fi = new FileInfo(videoFileFullPath);
                                fi.MoveTo(newStr);


                                ////转移到网路目录
                                CopyFilesToServer();
                            }
                        }
                    }
                }

            }
            catch (Exception ex)
            {
                videoWriter.Close();
                videoWriter.Dispose();
            }
            finally
            {

                if (this.g != null) this.g.Dispose();
            }

        }


        /// <summary>
        /// 开启或者关闭程序后将多余文件copy到相应目录，并开启磁盘映射上传到共享目录
        /// </summary>
        private void CopyFilesToServer()
        {
            try
            {
                //遍历 当前PC文件夹外是否存在视频文件，如存在，移动到目标目录
                string newPath = path + MacAddressPath + @"-Video\";
                if (!Directory.Exists(newPath)) Directory.CreateDirectory(newPath);
                //将上一次最后一个视频文件转入目录
                var files = Directory.GetFiles(path, "*.wmv");
                foreach (var file in files)
                {
                    FileInfo fi = new FileInfo(file);
                    string filesName = file.Split(new string[] { "\\" }, StringSplitOptions.RemoveEmptyEntries).LastOrDefault();
                    fi.MoveTo(newPath + filesName);
                }
            }
            catch (Exception ex)
            {

            }
            finally
            {

                uint state = 0;
                if (!Directory.Exists("Z:"))
                {
                    //计算机名
                    string computerName = System.Net.Dns.GetHostName();
                    //为网络共享目录添加磁盘映射 
                    //state = WNetHelper.WNetAddConnection(computerName + @"\" + netWorkUser, netWorkPwd, netWorkPath, "Z:");
                    state = WNetHelper.WNetAddConnection(netWorkPath, new NetworkCredential(netWorkUser, netWorkPwd), "Z:");
                }
                if (state.Equals(0))
                {
                    //本地磁盘视频文件copy到网络共享目录
                    CopyFolder(path + MacAddressPath + @"-Video\", zPath);
                }
                //if (Directory.Exists("Z:"))
                else
                {
                    WNetHelper.ExecCommand("NET USE * /DELETE /Y", 0);
                    throw new Exception("添加网络驱动器错误，错误号：" + state.ToString());
                }

            }
        }


    }
}
